﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Square : FlatLandObject
{

    public LineRenderer pathRenderer; // About drawing paths.
    public List<Vector2> pathList = new List<Vector2>();

    private Vector2 _currentPathEnd;

    // Start is called before the first frame update
    void Start()
    {
    }

    // Update is called once per frame
    void Update()
    {
        if(Input.GetMouseButtonDown(1)) // If right mouse button is clicked
        {
            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
            if (Physics.Raycast(ray, out RaycastHit hit)) // If the click was on the background
            {
                if (Input.GetKey(KeyCode.LeftShift) && pathRenderer.GetPosition(1) != Vector3.zero) // If shift is clicked and path is already exists
                    AddPath(hit.point);
                else
                    CreatePath(hit.point);
            }
        }
    }

    public IEnumerator MoveSquare(Vector2 destination)
    {
        speedVector = destination - (Vector2)transform.position;
        Vector3 scaledVector = speedVector * Time.deltaTime;
        while (speedVector.x * (destination.x - transform.position.x) > 0 || speedVector.y * (destination.y - transform.position.y) > 0)
        {
            transform.position += scaledVector;
            yield return null;
        }

    }

    public void CreatePath(Vector3 point) // Creates the fitst path.
    {
        pathRenderer.positionCount = 2;
        pathRenderer.SetPositions(new Vector3[] { transform.position, point });
    }

    public void AddPath(Vector3 point) // Adds new path to current path.
    {
        pathRenderer.positionCount++;
        pathRenderer.SetPosition(pathRenderer.positionCount - 1, point);
    }

    public void Move()
    {
        StartCoroutine(_StartMovingPath());
    }


    public IEnumerator _StartMovingPath()
    {
        Vector3[] tomoveList = new Vector3[pathRenderer.positionCount];
        Debug.Log(pathRenderer.positionCount);
        pathRenderer.GetPositions(tomoveList);
        for(int i = 1; i < pathRenderer.positionCount; i++)
        {
            yield return StartCoroutine(MoveSquare(tomoveList[i]));
        }

        ResetPaths();
    }

    public void ResetPaths()
    {
        pathRenderer.positionCount = 2;
        pathRenderer.SetPositions(new Vector3[] { Vector3.zero, Vector3.zero });
    }
}
